package com.fp.persistence.pviaticos.solicitud;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de VIA_SOL_COMENTARIOS*/
@Embeddable
public class ViaSolicitudComentariosKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="COD_SOLICITUD", nullable=false,updatable=false)

/**
* Numero de solicitud de viaticos
*/
private String cod_solicitud;

@Column(name="COD_TIPO", nullable=false,updatable=false)

/**
* Campo para el codigo del documento
*/
private String cod_tipo;

@Column(name="COD_SECUENCIA", nullable=false,updatable=false)

/**
* Campo secuancial para los comentarios
*/
private Integer cod_secuencia;

/**Contructor por defecto*/
public ViaSolicitudComentariosKey(){}
/**Contructor de ViaSolicitudComentariosKey
@param pCod_solicitud Numero de solicitud de viaticos
@param pCod_tipo Campo para el codigo del documento
@param pCod_secuencia Campo secuancial para los comentarios
*/
public ViaSolicitudComentariosKey(String pCod_solicitud,String pCod_tipo,Integer pCod_secuencia){
 cod_solicitud=pCod_solicitud;
 cod_tipo=pCod_tipo;
 cod_secuencia=pCod_secuencia;
}
/**Obtiene el valor de cod_solicitud
@return valor de cod_solicitud*/
public String getCod_solicitud(){
  return cod_solicitud;
}
/**Fija el valor de cod_solicitud
@param pCod_solicitud nuevo Valor de cod_solicitud*/
public void setCod_solicitud(String pCod_solicitud){
  cod_solicitud=pCod_solicitud;
}

/**Obtiene el valor de cod_tipo
@return valor de cod_tipo*/
public String getCod_tipo(){
  return cod_tipo;
}
/**Fija el valor de cod_tipo
@param pCod_tipo nuevo Valor de cod_tipo*/
public void setCod_tipo(String pCod_tipo){
  cod_tipo=pCod_tipo;
}

/**Obtiene el valor de cod_secuencia
@return valor de cod_secuencia*/
public Integer getCod_secuencia(){
  return cod_secuencia;
}
/**Fija el valor de cod_secuencia
@param pCod_secuencia nuevo Valor de cod_secuencia*/
public void setCod_secuencia(Integer pCod_secuencia){
  cod_secuencia=pCod_secuencia;
}

/**Implementacion de la comparacion de ViaSolicitudComentariosKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof ViaSolicitudComentariosKey))return false;
  ViaSolicitudComentariosKey that = (ViaSolicitudComentariosKey) o;
  if (this.getCod_solicitud() == null || that.getCod_solicitud() == null){
      return false;
  }
  if (! this.getCod_solicitud().equals(that.getCod_solicitud())){
    return false;
  }
  if (this.getCod_tipo() == null || that.getCod_tipo() == null){
      return false;
  }
  if (! this.getCod_tipo().equals(that.getCod_tipo())){
    return false;
  }
  if (this.getCod_secuencia() == null || that.getCod_secuencia() == null){
      return false;
  }
  if (! this.getCod_secuencia().equals(that.getCod_secuencia())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia ViaSolicitudComentariosKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCod_solicitud() == null ? 0 : this.getCod_solicitud().hashCode());
    result = result * 37 + (this.getCod_tipo() == null ? 0 : this.getCod_tipo().hashCode());
    result = result * 37 + (this.getCod_secuencia() == null ? 0 : this.getCod_secuencia().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
